/// @cond EO_CXX_EO_IMPL

inline bool elm::check::state_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_check_state_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::check::state_set(bool state_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_check_state_set(::efl::eolian::to_c(state_)));
}

inline void elm::check::state_pointer_set(bool* statep_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_check_state_pointer_set(::efl::eolian::to_c(statep_)));
}

inline bool eo_cxx::elm::check::state_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_check_state_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::check::state_set(bool state_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_check_state_set(::efl::eolian::to_c(state_)));
}

inline void eo_cxx::elm::check::state_pointer_set(bool* statep_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_check_state_pointer_set(::efl::eolian::to_c(statep_)));
}

inline ::eo_cxx::elm::check::operator ::elm::check() const
{
   return *static_cast<::elm::check const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::check::operator ::elm::check&()
{
   return *static_cast<::elm::check*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::check::operator ::elm::check const&() const
{
   return *static_cast<::elm::check const*>(static_cast<void const*>(this));
}

template <typename T>
bool elm_check_state_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->state_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_check_state_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool state_)
{
   try
      {
         static_cast<T*>(self->this_)->state_set(::efl::eolian::to_cxx<bool>(state_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_check_state_pointer_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool * statep_)
{
   try
      {
         static_cast<T*>(self->this_)->state_pointer_set(::efl::eolian::to_cxx<bool*>(statep_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::check >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::elm_interface_atspi_widget_action >::template type<T>
   {
      virtual bool state_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_check_state_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void state_set(bool state_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_check_state_set(::efl::eolian::to_c(state_)));
      }

      virtual void state_pointer_set(bool* statep_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_check_state_pointer_set(::efl::eolian::to_c(statep_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::check >
{
   static constexpr int value = 
#if defined(CHECK_PROTECTED) && defined(CHECK_BETA)
      3
#elif defined(CHECK_PROTECTED)
      3
#elif defined(CHECK_BETA)
      3
#else
      3
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::elm_interface_atspi_widget_action >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::check>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_check_state_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_check_state_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_check_state_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_check_state_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_check_state_pointer_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_check_state_pointer_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::check >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_widget_action>(), &ops[operation_description_class_size< ::elm::check >::value + operation_description_class_size<::elm::layout>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::check>)
{
   return (ELM_CHECK_CLASS);
}

} } }

/// @endcond

